VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Developers Code Book 3"
'----------------------------------------
'- Name: Sam Huggill
'- Email: sam@vbsquare.com
'- Web: http://www.vbsquare.com/
'- Company: Lighthouse Internet Solutions
'- Date/Time: 14/08/99 11:25:01
'----------------------------------------
'- Notes:   Connect class that implements
'           the IDTExensibilty interface
'           for the addin
'----------------------------------------

Option Explicit

Implements IDTExtensibility

Public FormDisplayed          As Boolean
Public VBInstance             As VBIDE.VBE
Dim mcbMenuCommandBar         As Office.CommandBarControl
Dim mfrmAddIn                 As frmMain
Public WithEvents MenuHandler As CommandBarEvents
Attribute MenuHandler.VB_VarHelpID = -1
Private WithEvents ButtonHandler As CommandBarEvents 'command bar event handler
Attribute ButtonHandler.VB_VarHelpID = -1
Private WithEvents HeaderHandler As CommandBarEvents
Attribute HeaderHandler.VB_VarHelpID = -1
Private WithEvents BarHandler As CommandBarEvents
Attribute BarHandler.VB_VarHelpID = -1
Private WithEvents HTMLHandler As CommandBarEvents
Attribute HTMLHandler.VB_VarHelpID = -1
Private Toolbar As Office.CommandBar
Private Button As Office.CommandBarControl
Private Header As Office.CommandBarControl
Private HTML As Office.CommandBarControl


Sub Hide()

    On Error Resume Next

    FormDisplayed = False
    mfrmAddIn.Hide

End Sub

Sub Show()

     On Error Resume Next

    If mfrmAddIn Is Nothing Then
        Set mfrmAddIn = frmMain
    End If

    Set mfrmAddIn.VBInstance = VBInstance
    Set mfrmAddIn.Connect = Me
    FormDisplayed = True
    mfrmAddIn.Show

End Sub

Private Sub ButtonHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
'    Me.Show
Set frmMain.VBInstance = Me.VBInstance
frmMain.Show
End Sub

Private Sub HeaderHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    On Error GoTo vbErrTrap

    With VBInstance.ActiveCodePane.CodeModule
        .InsertLines 1, "'----------------------------------------"
        .InsertLines 1, "'" & vbTab & vbTab
        .InsertLines 1, "'- Notes:" & vbTab
        .InsertLines 1, "'----------------------------------------"
        .InsertLines 1, "'- Date/Time: " & Now
        .InsertLines 1, "'- Company: " & GetSetting(ThisApp, "General", "Company", "")
        .InsertLines 1, "'- Web: " & GetSetting(ThisApp, "General", "Web", "")
        .InsertLines 1, "'- Email: " & GetSetting(ThisApp, "General", "Email", "")
        .InsertLines 1, "'- Name: " & GetSetting(ThisApp, "General", "Name", "")
        .InsertLines 1, "'----------------------------------------"
    End With

    Exit Sub
vbErrTrap:

End Sub

Private Sub HTMLHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    On Error GoTo vbErrHand
    
    Clipboard.SetText VBInstance.ActiveCodePane.CodeModule.Lines(1, VBInstance.ActiveCodePane.CodeModule.CountOfLines)
    frmMain.ctlData1.Paste
    frmMain.SourceToHTML frmMain.ctlData1.Code
    
    Exit Sub
vbErrHand:
    
End Sub

'------------------------------------------------------
'this method adds the Add-In to VB
'------------------------------------------------------
Private Sub IDTExtensibility_OnConnection(ByVal VBInst As Object, ByVal ConnectMode As vbext_ConnectMode, ByVal AddInInst As VBIDE.AddIn, custom() As Variant)

    On Error GoTo error_handler

    'save the vb instance
    Set VBInstance = VBInst

    'this is a good place to set a breakpoint and
    'test various addin objects, properties and methods
    Debug.Print VBInst.FullName

    If ConnectMode = vbext_cm_External Then
        'Used by the wizard toolbar to start this wizard
        Me.Show
    Else
        Set mcbMenuCommandBar = AddToAddInCommandBar("My AddIn")
        'sink the event
        Set Me.MenuHandler = VBInst.Events.CommandBarEvents(mcbMenuCommandBar)
    End If

    If ConnectMode = vbext_cm_AfterStartup Then
        If GetSetting(App.Title, "Settings", "DisplayOnConnect", "0") = "1" Then
            'set this to display the form on connect
            Me.Show
        End If
    End If
    
        
    InitColorize
    frmMain.ctlData1.SetColours

    Exit Sub

error_handler:

    '  MsgBox Err.Description

End Sub

'------------------------------------------------------
'this method removes the Add-In from VB
'------------------------------------------------------
Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As vbext_DisconnectMode, custom() As Variant)

    On Error Resume Next

    'delete the command bar entry
    mcbMenuCommandBar.Delete
    Button.Delete
    Toolbar.Delete
    'shut down the Add-In
    If FormDisplayed Then
        SaveSetting App.Title, "Settings", "DisplayOnConnect", "1"
        FormDisplayed = False
    Else
        SaveSetting App.Title, "Settings", "DisplayOnConnect", "0"
    End If

    Unload mfrmAddIn
    Set mfrmAddIn = Nothing

End Sub

Private Sub IDTExtensibility_OnStartupComplete(custom() As Variant)
    If GetSetting(App.Title, "Settings", "DisplayOnConnect", "0") = "1" Then
        'set this to display the form on connect
        Me.Show
    End If
End Sub

Private Sub IDTExtensibility_OnAddInsUpdate(custom() As Variant)
    '
End Sub

'this event fires when the menu is clicked in the IDE
Private Sub MenuHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Me.Show
End Sub

Function AddToAddInCommandBar(sCaption As String) As Office.CommandBarControl
    Dim cbMenuCommandBar As Office.CommandBarControl  'command bar object
    Dim cbMenu As Object

    Set Toolbar = VBInstance.CommandBars.Add("Developers Code Book", msoAnchorTop)
    Toolbar.Enabled = True

    Set Button = Toolbar.Controls.Add(1, , , 1)
    Button.Enabled = True
    Button.FaceId = 942
    Button.ToolTipText = "Launch the Developers Code Book"
    Button.Caption = "DCB 3"

    Set HTML = Toolbar.Controls.Add(1, , , 1)
    HTML.Enabled = True
    HTML.FaceId = 1922
    HTML.ToolTipText = "Convert to HTML page"

    Set Header = Toolbar.Controls.Add(1, , , 1)
    Header.Enabled = True
    Header.FaceId = 9
    Header.ToolTipText = "Insert custom header"
    
    Set HTMLHandler = VBInstance.Events.CommandBarEvents(HTML)
    Set HeaderHandler = VBInstance.Events.CommandBarEvents(Header)
    Set ButtonHandler = VBInstance.Events.CommandBarEvents(Button)
    Set BarHandler = VBInstance.Events.CommandBarEvents(Toolbar)

    On Error GoTo AddToAddInCommandBarErr

    'see if we can find the Add-Ins menu
    Set cbMenu = VBInstance.CommandBars("Add-Ins")
    If cbMenu Is Nothing Then
        'not available so we fail
        Exit Function
    End If

    'add it to the command bar
    Set cbMenuCommandBar = cbMenu.Controls.Add(1)
    'set the caption
    cbMenuCommandBar.Caption = sCaption

    Toolbar.Visible = True
    Toolbar.Position = msoBarMenuBar
    Toolbar.Protection = msoBarNoVerticalDock

    Set AddToAddInCommandBar = cbMenuCommandBar

    Exit Function

AddToAddInCommandBarErr:

End Function
