Attribute VB_Name = "modDeclares"
'----------------------------------------
'- Name: Sam Huggill
'- Email: sam@vbsquare.com
'- Web: http://www.vbsquare.com/
'- Company: Lighthouse Internet Solutions
'- Date/Time: 14/08/99 11:30:17
'----------------------------------------
'- Notes:   Contains all the API declares,
'           constants and type structures
'           for the application
'----------------------------------------

'API Calls for about information
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'General Windows API Calls
Public Declare Function SendMessageAny Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageByLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function WritePrivateProfileString Lib "Kernel32" Alias "WritePrivateProfileStringA" (ByVal AppName As String, ByVal KeyName As String, ByVal keydefault As String, ByVal FileName As String) As Long

'ChooseColour Dialog API
Public Declare Function ShowColour Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long

'General Windows Styles
Public Const WM_USER = &H400
Public Const GWL_STYLE = -16&
Public Const CLR_INVALID = -1
Public Const TCS_FLATBUTTONS = &H8
Public Const SM_CXVSCROLL As Long = 2 ' Get Width Of Vertical ScrollBar

'Textbox Messages
Public Const EM_LINELENGTH = &HC1
Public Const EM_LINEINDEX = &HBB
Public Const EM_GETLINECOUNT = &HBA
Public Const EM_LINEFROMCHAR = &HC9
Public Const EM_GETSEL = &HB0
Public Const EM_GETLINE = &HC4
Public Const EM_REPLACESEL = &HC2

'Treeview Styles
Public Const TVM_SETBKCOLOR = 4381&
Public Const TVM_GETBKCOLOR = 4383&
Public Const TVS_HASLINES = 2&
Public Const TV_FIRST As Long = &H1100
Public Const TVM_GETTEXTCOLOR As Long = (TV_FIRST + 32)
Public Const TVM_SETTEXTCOLOR As Long = (TV_FIRST + 30)
Public Const TVS_CHECKBOXES = &H100
Public Const TVS_TRACKSELECT = &H200
Public Const TVM_GETNEXTITEM As Long = (TV_FIRST + 10)
Public Const TVM_GETITEM As Long = (TV_FIRST + 12)
Public Const TVM_SETITEM As Long = (TV_FIRST + 13)
Public Const TVIF_STATE As Long = &H8
Public Const TVIS_BOLD As Long = &H10
Public Const TVGN_CARET As Long = &H9
Public Const TVS_FULLROWSELECT As Long = &H1000
Public Const TVGN_ROOT As Long = &H0
Public Const TVM_DELETEITEM As Long = (TV_FIRST + 1)
Public Const WM_VSCROLL = &H115
Public Const WM_SETREDRAW As Long = &HB

'Public members for the program
Public db As Database
Public Const ThisApp = "VB Square Developers Code Book"
Public blnFind As Boolean

'Treeview Item type
Public Type TVITEM
    mask As Long
    hItem As Long
    State As Long
    stateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long
    iSelectedImage As Long
    cChildren As Long
    lParam As Long
End Type

'Windows Type Structures
Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type RECT
    left       As Long
    tOp        As Long
    Right      As Long
    Bottom     As Long
End Type

'Drag and drop message type
Type Msg
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

'// Listview Images Type
Public Type LVBKIMAGE
    ulFlags As Long
    hbm As Long
    pszImage As String
    cchImageMax As Long
    xOffsetPercent As Long
    yOffsetPercent As Long
End Type

'List View Styles
Public Const LVM_FIRST As Long = &H1000
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE As Long = LVM_FIRST + 54
Public Const LVM_GETEXTENDEDLISTVIEWSTYLE As Long = LVM_FIRST + 55
Public Const LVS_EX_FULLROWSELECT = &H20
Public Const HDS_BUTTONS As Long = &H2
Public Const LVM_GETCOLUMNWIDTH As Long = LVM_FIRST + 29
Public Const LVM_SETCOLUMNWIDTH As Long = LVM_FIRST + 30
Public Const LVSCW_AUTOSIZE_USEHEADER = -2
Public Const LVBKIF_SOURCE_URL = &H2
Public Const LVBKIF_STYLE_TILE = &H10
Public Const LVM_SETBKIMAGEA = (LVM_FIRST + 68)
Public Const LVM_SETBKIMAGE = LVM_SETBKIMAGEA
Public Const LVM_SETTEXTBKCOLOR = (LVM_FIRST + 38)
Public Const CLR_NONE = &HFFFFFFFF
Public Const LVM_GETHEADER = (LVM_FIRST + 31)
Public Const HDS_HOTTRACK = &H4 ' v 4.70

'Constant for the status bar
Public Const SB_GETRECT As Long = (WM_USER + 10)

'Clipboard Calls
Public Declare Function RegisterClipboardFormat Lib "user32" Alias "RegisterClipboardFormatA" (ByVal lpString As String) As Integer

'ChooseColourType Structure
Public Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
'// Export/Import Type
Public Type FileDetails
    sName As String
    sOldID As String
    sParentID As String
    sNewID As String
    sParentName As String
    sCode As String
    sNotes As String
    sExample As String
    sImage As String
    sVersion As String
    sLevel As String
    bFolder As Boolean
End Type
'// File Dialog Enum
Public Enum eFileDialog
    eSave
    eOpen
End Enum

Public Type FileHeader
    lNumberOfRecords As Long
End Type

'Windows Undo constants
Public Const EM_CANUNDO = &HC6
Public Const EM_UNDO = &HC7

'Printing API Calls
Public Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" _
        (ByVal lpDriverName As String, ByVal lpDeviceName As String, _
        ByVal lpOutput As Long, ByVal lpInitData As Long) As Long

Public Declare Function GetDeviceCaps Lib "gdi32" ( _
        ByVal hdc As Long, ByVal nIndex As Long) As Long

'// Combo box constants
Public Const CB_FINDSTRING As Long = &H14C
Public Const CB_ERR = (-1)
Public Const CB_SETCURSEL = &H14E

Public g_strName As String
Public g_strLink As String
Public g_blnEnd As Boolean

